<?php
// IziTranslate.php
// http://blog.niap3d.com/fr/1,10,news-47-Internationaliser-un-site-partie-4-.html
// initialise la session
if(ini_get('session.use_trans_sid')){
	ini_set('session.use_trans_sid', 0);
	ini_set('session.use_only_cookies', 1);
}
session_start();

// vérifie si les variables de session existent et n'ont pas expiré
if(empty($_SESSION['ITE']['path'])){
	if($_GET['do']!='param' && $_GET['do']!='paramInit'){
		// les variables de sessions sont vides
		// on affiche une alerte, il faut les paramétrer
		$html = '<p id="ITE_back"><a href="IziTranslate.php?do=param">Paramètres</a></p>
		<h1>Erreur</h1>
		<p>La session est vide !</p>';
		unset($_GET['do']);
	}

}else{
	// import les classe IziTranslate et IziTranslateEdit
	require 'IziTranslate.class.php';
	require 'IziTranslateEdit.class.php';
	// crée l'objet
	$ITE = new IziTranslateEdit($_SESSION['ITE']['path']);
	// ajoute les langues définis dans la session
	foreach($_SESSION['ITE']['lang'] as $k=>$v){
		$ITE->AddLanguage($k, $v);
	}
	// initialise la liste des fichiers
	$fileLst = $ITE->GetFileList();
	// cherche si un fichier est passé en paramètre
	$fileNb = intval($_GET['fileNb']);
	if($fileNb==0 || $fileNb>count($fileLst)) $fileNb = intval($_POST['fileNb']);
	if($fileNb==0 || $fileNb>count($fileLst)) $fileNb = 1;
	$fileNb--;
	// initialise le fichier à ouvrir
	$ITE->EditTxt($fileLst[$fileNb]);
} 

// genère le contenu de la page page
switch($_GET['do']){
case 'translateSave' :
	// enregistre les textes
	if(!$ITE) die("L'objet IziTranslate n'est pas initialisé...");
	$html = '<p id="ITE_back"><a href="IziTranslate.php?do=chooseFile">Retour</a></p>';
	if($ITE->SaveFromPostValue()){
		// les modifications sont enregistrés
		$html .= '<h1>Modifications enregistrées</h1>';
	}else{
		// une erreur est survenue
		$html .= '<h1>Erreur</h1>';
	}
	break;

case 'openFile' :
	// formulaire pour éditer les textes
	if(!$ITE) die("L'objet IziTranslate n'est pas initialisé...");
	$html = '<p id="ITE_back"><a href="IziTranslate.php?do=chooseFile">Retour</a></p>
	<h1>Textes du fichier "'.$fileLst[$fileNb].'"</h1>
	<form action="IziTranslate.php?do=translateSave&amp;fileNb='.($fileNb+1).'" method="post">
	<div id="ITE_Table">'.$ITE->GetHtml().'</div>
	<input type="submit" value="Enregistrer">
	</form>';
	break;

case 'paramInit' :
	// enregistre les paramètres (chemin d'accès et les langes)
	$p = $_POST['paramPath'];
	// verifie le chemin d'accès
	if(!is_dir($p)){
		// le chemin n'existe pas
		$html = '<p id="ITE_back"><a href="IziTranslate.php?do=param">Retour</a></p>
		<h1>Erreur</h1>
		<p>Le chemin d\'accès "$p" n\'existe pas !</p>';
		
	}else{
		// le chemin existe, on enregistre les données dans une variable de session
		$a = array();
		$a['path'] = $p;
		$a['lang'] = array();
		foreach($_POST as $k=>$v){
			if(substr($k, 0, 9)=='lang_nom_'){
				// vérifie si la valeur du titre n'est pas vide
				if(empty($v)) continue;
				// cherche l'identifiant lié au titre
				$id = substr($k, 9, strlen($k)-9);
				// vérifie si le dossier existe
				$p2 = $p.'/'.$_POST['lang_id_'.$id];
				if(!is_dir($p2)) $ok = mkdir($p2);
				else $ok = 1;
				// si le dossier existe (ou a été crée) crée une clé dans le tableau des langues
				if($ok) $a['lang'][$_POST['lang_id_'.$id]] = $v;
			}
		}
		$_SESSION['ITE'] = $a;
		header("Location: ".basename(__FILE__)."?do=chooseFile");
	}
	break;

case 'newFile' :
	// formulaire pour créer un nouveau fichier
	$html = '<p id="ITE_back"><a href="IziTranslate.php?do=chooseFile">Retour</a></p>
<form action="IziTranslate.php?do=createNewFile" method="post">
<h1>Créer un nouveau fichier</h1>
<p><span>Nom du fichier : </span><input size="50" name="fileName" id="champ_fileName" value=".json" type="text"></p>
<input type="submit" value="Créer">
</form>';
	break;

case 'createNewFile' :
	// crée un nouveau fichier vide
	$p = trim($_POST['fileName']);
	if($p=='.json'){
		//  le nom du fichier est '.json'
		$html = '<p id="ITE_back"><a href="IziTranslate.php?do=newFile">Retour</a></p>
		<h1>Erreur</h1>
		<p>Le nom du fichier est vide !</p>';

	}else{
		reset($_SESSION['ITE']['lang']);
		if(!$f = fopen($_SESSION['ITE']['path'].'/'.key($_SESSION['ITE']['lang']).'/'.$p, 'w')){
			$html .= '<p id="ITE_back"><a href="IziTranslate.php?do=newFile">Retour</a></p>
			<h1>Erreur</h1>
			<p>Une erreur est survenue à la création du fichier !</p>';
			
		}else{
			fwrite($f, json_encode(array()));
			fclose($f);
			header("Location: ".basename(__FILE__)."?do=chooseFile");
		}
	}
	break;

case 'chooseFile' :
	// formulaire pour choisir le fichier à éditer
	$html = '<p id="ITE_back"><a href="IziTranslate.php?do=param">Paramètres</a></p>
<h1>Choisissez le fichier à éditer : </h1>
<ul id="ITE_FileList">';
	foreach($fileLst as $k=>$v){
		$html .= '<li><a href="IziTranslate.php?do=openFile&amp;fileNb='.($k+1).'">'.$v.'</a></li>';
	}
	$html .= '</ul>
<form action="IziTranslate.php?do=newFile" method="post">
<input type="submit" value="Créer un nouveau fichier">
</form>';
	break;

case 'param' :
	// formulaire pour choisir le fichier à éditer
	$html = '<h1>Paramétrez le chemin d\'accès</h1>
<form action="IziTranslate.php?do=paramInit" method="post">
<p><span>Chemin d\'accès vers le dossier langue : </span><input size="50" name="paramPath" id="champ_paramPath" value="lang" type="text"></p>
<h1>Langues</h1>
<div id="langLst">
</div>
<p><input name="lineAdd" value="+" onclick="IziTranslateEditAddLang(\'\', \'\')" type="button"></p>
<input type="submit" value="Continuer">
</form>
<script type="text/javascript">
//&lt;![CDATA[
var IziTranslateEditLangNb = 0;
function IziTranslateEditAddLang(tId, tName){
	var elParent = document.getElementById("langLst");
	if(elParent==undefined) return 0;
	var el = document.createElement("div");
	IziTranslateEditLangNb++;
	el.id = "info"+IziTranslateEditLangNb;
	var html = \'<fieldset>\';
	html += \'<legend>Langue \'+IziTranslateEditLangNb+\'</legend>\';
	html += \'<p><span>Nom : </span><input type="text" size="35" name="lang_nom_\'+IziTranslateEditLangNb+\'" id="champ_lang_nom_\'+IziTranslateEditLangNb+\'" value="\'+tName+\'" /></p>\';
	html += \'<p><span>Dossier : </span><input type="text" size="35" name="lang_id_\'+IziTranslateEditLangNb+\'" id="champ_lang_id_\'+IziTranslateEditLangNb+\'" value="\'+tId+\'" /></p>\';
	html += \'<p><span> </span>Uniquement des caractères compatibles avec un chemin d\\\'accès</p>\';
	html += \'</fieldset>\';
	el.innerHTML = html;
	elParent.appendChild(el);
	return 1;
}
IziTranslateEditAddLang("fr", "Français");
IziTranslateEditAddLang("en", "English");
//]]&gt;
</script>';
	break;
}

// affiche les balises html
echo '<!DOCTYPE html>
<html lang="FR">
<head>
	<title>IziTranslate</title>
	<meta charset="utf-8" />
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<style type="text/css">
body{
	background-color: #eeefee;
	font-family: "Lucida Grande", Lucida, Verdana, sans-serif;
	font-size: 14px;
	text-align: left;
}
h1, p, form{
	text-align: center;
}
h1{
	font-family: Impact;
	font-weight: normal;
}
fieldset{
	margin: 0 15%;
}
fieldset, fieldset p{
	text-align: left;
}
fieldset span{
	display: block;
	float: left;
	width: 30%;
	margin: 2px 4px 0 0;
	text-align: right;
}
input[type=submit]{
	padding: 0.5em 3em;
	border: 1px dotted #000;
	font-size: 1.5em;
}
input[type=submit]:hover{
	background-color: #b3e6ef;
	border: 1px solid #b3e6ef;
}
/* bouton de retour */
#ITE_back{
	text-align: left;
}
#ITE_back a{
	text-decoration: none;
	color: #000;
	border: 1px dotted #000;
	padding: 0.5em 1em;
}
#ITE_back a:hover{
	background-color: #000;
	color: #fff;
}
/* choix du fichier */
#ITE_FileList li{
	margin: 0;
	padding: 0;
	list-style: none;
}
#ITE_FileList a{
	display: block;
	margin: 0 3em;
	padding: 0.5em 0;
	border: 1px solid #bbb;
	border-top-color: #fff;
	border-left-color: #fff;
	background-color: #ddd;
	color: #000;
	text-align: center;
	text-decoration: none;
	font-size: 1.25em;
}
#ITE_FileList a:hover{
	background-color: #b3e6ef;
	border-color: #fff;
	border-top-color: #bbb;
	border-left-color: #bbb;
}
/* tableau d\'édition */
#ITE_Table{
	width: 80%;
	margin: auto;
	margin-bottom: 1em;
	overflow: auto;
}
#ITE_Table p{
	text-align: left;
}
#ITE_Table table{
	width: 100%;
	margin: auto;
	border-collapse: separate;
	border-spacing: 0;
}
#ITE_Table td{
	padding: 4px;
	border: 1px solid #bbb;
	border-top-color: #fff;
	border-left-color: #fff;
	vertical-align: top;
}
#ITE_Table tr:nth-child(even) td{
	background-color: #ddd;
}
#ITE_Table tr:nth-child(odd) td{
	background-color: #eee;
}
#ITE_Table tr:hover td{
	background-color: #b3e6ef;
}
#ITE_Table th{
	background: none;
}
#ITE_Table input[type=text], #ITE_Table textarea{
	width: 100%;
	margin: 1px;
	border: none;
	background: none;
	resize: none;
}
#ITE_Table input[type=text]{
	font-weight: bold;
}
#ITE_Table tr:hover input[type=text], #ITE_Table tr:hover textarea{
	margin: 0;
	border: 1px solid #888;
	background-color: #fff;
	resize: vertical;
}
</style>
</head>
<body>'.$html.'</body>
</html>';
?>