<?php
// class IziTranslateEdit
// http://blog.niap3d.com/fr/1,10,news-46-Internationaliser-un-site-partie-3-.html
class IziTranslateEdit extends IziTranslate{
	protected $filePath = '';
	//
	// Charge un fichier pour le modifier
	//
	// argument :
	//		$aFile = nom du fichier à éditer
	//
	public function EditTxt($aFile){
		if($this->LoadTxt($aFile)) $this->filePath = $aFile;
	}
	//
	// renvoi un tableau html les textes
	//
	public function GetHtml(){
		if(!$this->langRef) return '';
		$h = '<table id="IziTranslateEditTable">';
		$h .= '<tr><th>Identifiant</th>';
		// affiche le nom de la langue en entete
		foreach($this->langLst as $k1=>$v1){
			$h .= '<th>'.($v1=='' ? $k1:$v1).'</th>';
		}
		$h .= '<th></th></tr>';
		// boucle a travers toutes les clé de la langue de référence
		$l = 0;
		foreach($this->txt[$this->langRef] as $k1=>$v1){
			$l++;
			// ajoute le champ de l'identifiant
			$h .= '<tr><td><input type="text" size="35" name="title_'.$l.'" id="champ_title_'.$l.'" value="'.$k1.'" /></td>';
			// cherche dans chaque langue la clé trouvé dans la langue de référence et ajoute une zone de texte
			foreach($this->langLst as $k2=>$v2){
				$h .= '<td><textarea rows="4" cols="40" name="'.$k2.'_'.$l.'" id="champ_'.$k2.'_'.$l.'">'.$this->txt[$k2][$k1].'</textarea></td>';
			}
			// bouton pour supprimer la ligne
			$h .= '<td><input type="button" name="lineDel" value="-" onclick="IziTranslateEditDelLine(this)"></td></tr>';
		}
		$h .= '</table>';
		// bouton pour ajouter une nouvelle ligne
		$h .= '<p><input type="button" name="lineAdd" value="+" onclick="IziTranslateEditAddLine()"></p>';
		// code javascript
		$h .= '<script type="text/javascript">
//<![CDATA[
var IziTranslateEditTxtNb = '.$l.';
function IziTranslateEditAddLine(){
	var el = document.getElementById("IziTranslateEditTable");
	if(el==undefined) return 0;
	var lang= new Array("'.implode('","', array_keys($this->langLst)).'");
	var row = el.insertRow(-1);
	IziTranslateEditTxtNb++;
	var html = \'<td><input type="text" size="35" name="title_\'+IziTranslateEditTxtNb+\'" id="champ_title_\'+IziTranslateEditTxtNb+\'"></td>\'
	for(var i=0; i<lang.length; i++){
		html += \'<td><textarea rows="4" cols="40" name="\'+lang[i]+\'_\'+IziTranslateEditTxtNb+\'" id="champ_\'+lang[i]+\'_\'+IziTranslateEditTxtNb+\'"></textarea></td>\';
	}
	html += \'<td><input type="button" name="lineDel" value="-" onclick="IziTranslateEditDelLine(this)"></td>\'
	row.innerHTML = html;
	return 1;
}
function IziTranslateEditDelLine(aCell){
	var el = document.getElementById("IziTranslateEditTable");
	if(el==undefined) return 0;
	var row = aCell.parentNode.parentNode;
	el.deleteRow(row.rowIndex);
	return 1;
}
//]]>
</script>';
		return $h;
	}
	//
	// renvoi la liste des fichiers enregistrés dans le dossier lang de référence
	//
	public function GetFileList(){
		$l = @scandir($this->pathLang.'/'.$this->langRef.'/', 1);
		$l2 = array();
		if(!empty($l)){
			foreach($l as $f){
				if($f!='.' && $f!='..') $l2[] = $f;
			}
		}
		return $l2;
	}
	//
	// enregistre les textes de chaque langues
	//
	public function SaveFromPostValue(){
		// initialise le tableau des textes
		$this->txt = array();
		foreach($this->langLst as $k2=>$v2){
			$this->txt[$k2] = array();
		}
		// boucle à travers les données $_POST
		foreach($_POST as $k=>$v){
			// cherche les champs dont le nom commencent par title
			if(substr($k, 0, 5)=='title'){
				// vérifie si la valeur du titre n'est pas vide
				if(empty($v)) continue;
				// cherche l'identifiant lié
				$id = substr($k, 6, strlen($k)-6);
				// pour chaque langue cherche le texte qui correspond [identifiant de la langue]_[identifiant champ]
				foreach($this->langLst as $k2=>$v2){
					if(!empty($_POST[$k2.'_'.$id])) $this->txt[$k2][$v] = $_POST[$k2.'_'.$id];
				}
			}
		}
		// enregistre les fichiers
		foreach($this->langLst as $k1=>$v1){
			$p = $this->pathLang.'/'.$k1.'/'.$this->filePath;
			if(!$f = fopen($p, 'w')){
				return 0;
			}else{
				fwrite($f, json_encode($this->txt[$k1]));
				fclose($f);
			}
		}
		return 1;
	}
}
?>